/*---------------------------------------------------------+
+ PROCEDURE  CRIA_FATOS                                    +
+ FUNO: CRIAO DE FATOS DE DW NA BASE DE DADOS          +
+                                                          +
+ CRIAO: 28/09/2007                                      +
+ RAPHAEL ERNANI RODRIGUES                                 +
+                                                          +
+---------------------------------------------------------*/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'CRIA_FATOS' AND
	        TYPE = 'P' 	            AND
	        U.UID = O.UID               AND
	        U.NAME = USER)
	DROP PROCEDURE CRIA_FATOS
GO

create PROCEDURE CRIA_FATOS @P_CDTABELADW  VARCHAR(30),
                            @P_CDITEMDW    VARCHAR(30),
                            @P_NMITEMDW    VARCHAR(30),
                            @P_NMAREANEGDW VARCHAR(30)
AS
   DECLARE   @V_COUNT       INT;
   DECLARE   @V_COUNT2      INT;
   DECLARE   @V_CDAREANEGDW VARCHAR(05);
   DECLARE   @V_NMITEMDW    VARCHAR(30);
   DECLARE   @V_TRY         INT;
BEGIN
   BEGIN TRAN;
   SET @V_TRY = 0;   

   SELECT @V_COUNT = COUNT(*)
   FROM ITEMDW
   WHERE CDITEMDW   = @P_CDITEMDW
     AND CDTABELADW = @P_CDTABELADW;

   IF @V_COUNT=0
   BEGIN  
      SELECT @V_COUNT = COUNT(*)
      FROM   AREANEGDW
      WHERE  NMAREANEGDW = @P_NMAREANEGDW;     
      IF @V_COUNT=0
      BEGIN
            SELECT @V_CDAREANEGDW = RIGHT(REPLICATE('0', 5) + CAST(ISNULL(MAX(CDAREANEGDW)+1,0) AS VARCHAR), 5)        
            FROM AREANEGDW;
            
            INSERT INTO AREANEGDW
            (CDAREANEGDW,NMAREANEGDW)
            VALUES
            (@V_CDAREANEGDW,@P_NMAREANEGDW);         
      END
      ELSE
      BEGIN 
         SET ROWCOUNT 1;
         SELECT @V_CDAREANEGDW = CDAREANEGDW
         FROM   AREANEGDW
         WHERE  NMAREANEGDW = @P_NMAREANEGDW;
         SET ROWCOUNT 0;
      END;
      
      SET @V_NMITEMDW = @P_NMITEMDW;
      SET @V_COUNT    = 1; -- O SISTEMA DEVE ENTRAR NO LOOP PELO MENOS UMA VEZ

      WHILE @V_COUNT <> 0
      BEGIN 
         SELECT @V_COUNT = COUNT(*)
         FROM   ITEMDW
         WHERE  NMITEMDW = @V_NMITEMDW;
         IF @V_COUNT=0
         BEGIN
            SELECT @V_COUNT2 = COUNT(*) 
            FROM TABELADW
            WHERE CDTABELADW = @P_CDTABELADW;
            IF @V_COUNT2=0
            BEGIN
               INSERT INTO TABELADW 
               (CDTABELADW, NMTABELADW) 
               VALUES
               (@P_CDTABELADW, @P_CDTABELADW);
            END;
            
            
            INSERT INTO ITEMDW
            (CDTABELADW,   CDITEMDW,   NMITEMDW,   CDAREANEGDW,   IDFATODW, IDTPFATODW)
            VALUES
            (@P_CDTABELADW, @P_CDITEMDW, @V_NMITEMDW, @V_CDAREANEGDW, 'S',      'M');
         END
         ELSE
         BEGIN
            IF LEN(@V_NMITEMDW+CAST(@V_TRY AS VARCHAR))<=30 
            BEGIN
               SET @V_NMITEMDW = @V_NMITEMDW+CAST(@V_TRY AS VARCHAR);
            END
            ELSE
            BEGIN
               SET @V_TRY      = @V_TRY + 1;
               SET @V_NMITEMDW = @P_NMITEMDW;
               IF LEN(@V_NMITEMDW+CAST(@V_TRY AS VARCHAR))>=30
               BEGIN
                  SET @V_COUNT = 0;
               END;
            END;
         END;   
      END; -- LOOP
   END;
   COMMIT TRAN;
END
GO


--VERSAO--
EXEC ATUVEROBJ'CRIA_FATOS','4.11.000';
GO